--
-- LOCK, TRUNCATE
--

--
-- Reuse the table from bit.sql
--

CREATE TABLE ZPBIT_TABLE2(b BIT(11));

INSERT INTO ZPBIT_TABLE2 VALUES (B'');
INSERT INTO ZPBIT_TABLE2 VALUES (B'0');
INSERT INTO ZPBIT_TABLE2 VALUES (B'11011');
INSERT INTO ZPBIT_TABLE2 VALUES (B'10101010101');

BEGIN;
LOCK TABLE ZPBIT_TABLE2;
SELECT b FROM ZPBIT_TABLE2 WHERE b=B'10101010101'; 
INSERT INTO ZPBIT_TABLE2 VALUES (B'01010101011');
COMMIT;

CREATE TABLE VARBIT_TABLE2(v BIT VARYING(11));

INSERT INTO VARBIT_TABLE2 VALUES (B'');
INSERT INTO VARBIT_TABLE2 VALUES (B'0');
INSERT INTO VARBIT_TABLE2 VALUES (B'010101');
INSERT INTO VARBIT_TABLE2 VALUES (B'01010101010');

BEGIN WORK;
LOCK TABLE VARBIT_TABLE2 IN SHARE ROW EXCLUSIVE MODE;
SELECT * FROM VARBIT_TABLE2 WHERE v='010101'; 
INSERT INTO VARBIT_TABLE2 VALUES (B'01010101011');
COMMIT WORK;

BEGIN TRANSACTION;
LOCK TABLE VARBIT_TABLE2 IN SHARE MODE;
SELECT * FROM VARBIT_TABLE2 WHERE v='010101'; 
INSERT INTO VARBIT_TABLE2 VALUES (B'01010101001');
COMMIT TRANSACTION;

BEGIN TRANSACTION;
LOCK TABLE VARBIT_TABLE2 IN ROW SHARE MODE;
SELECT * FROM VARBIT_TABLE2 WHERE v='010101'; 
INSERT INTO VARBIT_TABLE2 VALUES (B'01010100001');
COMMIT TRANSACTION;

BEGIN;
LOCK TABLE VARBIT_TABLE2 IN ROW EXCLUSIVE MODE;
SELECT * FROM VARBIT_TABLE2 WHERE v='010101'; 
INSERT INTO VARBIT_TABLE2 VALUES (B'01010100110');
COMMIT;

BEGIN;
LOCK TABLE VARBIT_TABLE2 IN EXCLUSIVE MODE;
SELECT * FROM VARBIT_TABLE2 WHERE v='010101'; 
INSERT INTO VARBIT_TABLE2 VALUES (B'01010100110');
COMMIT;

BEGIN;
LOCK TABLE VARBIT_TABLE2 IN ACCESS SHARE MODE;
SELECT * FROM VARBIT_TABLE2 WHERE v='010101'; 
INSERT INTO VARBIT_TABLE2 VALUES (B'01010100100');
COMMIT;

BEGIN;
LOCK TABLE VARBIT_TABLE2 IN ACCESS EXCLUSIVE MODE;
LOCK TABLE ZPBIT_TABLE2;
SELECT * FROM VARBIT_TABLE2 WHERE v='010101'; 
INSERT INTO VARBIT_TABLE2 VALUES (B'01010100111');
ABORT;

BEGIN;
LOCK TABLE VARBIT_TABLE2 IN ACCESS EXCLUSIVE MODE;
LOCK TABLE VARBIT_TABLE2 IN ACCESS EXCLUSIVE MODE; -- lock again
LOCK TABLE VARBIT_TABLE2 IN ROW EXCLUSIVE MODE; -- lock again
SELECT * FROM VARBIT_TABLE2 WHERE v='010101'; 
INSERT INTO VARBIT_TABLE2 VALUES (B'01010100111');
ROLLBACK;

BEGIN;
LOCK TABLE VARBIT_TABLE2 IN ACCESS ROW MODE;
LOCK TABLE VARBIT_TABLE2 IN SHARE EXCLUSIVE MODE;
LOCK TABLE VARBIT_TABLE2 IN ACCESS MODE;
LOCK TABLE ZPBIT_TABLE2 IN MODE;
LOCK TABLE ZPBIT_TABLE3; -- table does not exist
COMMIT;

LOCK TABLE ZPBIT_TABLE3; -- table does not exist
LOCK TABLE ZPBIT_TABLE2; -- try to lock outside of a transaction
LOCK TABLE VARBIT_TABLE2; -- try to lock outside of a transaction

CREATE TABLE TAB_A(
   i1 int,
   i2 int
);

INSERT INTO TAB_A VALUES (1,2);
INSERT INTO TAB_A VALUES (2,4);
INSERT INTO TAB_A VALUES (3,6);

CREATE INDEX index1 ON TAB_A (i1);
CREATE VIEW view1 AS SELECT * FROM TAB_A;

/* TRUNCATE with invalid arguments */
TRUNCATE INDEX index1;
TRUNCATE TABLE index1;
TRUNCATE VIEW view1;
TRUNCATE sometable;
TRUNCATE;

SELECT * FROM ZPBIT_TABLE2;
SELECT * FROM VARBIT_TABLE2;

TRUNCATE TABLE ZPBIT_TABLE2;
TRUNCATE VARBIT_TABLE2;

SELECT * FROM ZPBIT_TABLE2;
SELECT * FROM VARBIT_TABLE2;

DROP VIEW view1;
DROP INDEX index1;
DROP TABLE TAB_A;
DROP TABLE ZPBIT_TABLE2;
DROP TABLE VARBIT_TABLE2;
