--
-- TRIGGERS
--

CREATE TABLE films2 (
   code		CHAR(5) PRIMARY KEY,
   title	VARCHAR(40),
   did		DECIMAL(3) UNIQUE
);

CREATE TABLE distributors2 (
   did		DECIMAL(3),
   name		VARCHAR(40),
   CONSTRAINT if_film_exists
   FOREIGN KEY(did) REFERENCES films2
   ON UPDATE CASCADE ON DELETE CASCADE
);

DROP TABLE distributors2;
CREATE TABLE distributors2 (
   did		DECIMAL(3),
   name		VARCHAR(40),
   CONSTRAINT if_film_exists
   FOREIGN KEY(did) REFERENCES films2(did)
   ON UPDATE CASCADE ON DELETE CASCADE
);

CREATE TRIGGER if_film_exits
   BEFORE DELETE OR UPDATE ON distributors2 FOR EACH ROW
   EXECUTE PROCEDURE check_foreign_key (1, 'CASCADE','did', 'films2', 'did');

INSERT INTO films2 VALUES ( 'L010','Lion King',101);
INSERT INTO films2 VALUES ( 'G999','The Godfather',102);
INSERT INTO films2 VALUES ( 'M231','Monster, Inc.',109);

INSERT INTO distributors2 VALUES (101, 'Warner Bros.');
INSERT INTO distributors2 VALUES (102, 'Paramount');
INSERT INTO distributors2 VALUES (103, 'Columbia');
INSERT INTO distributors2 VALUES (104, 'Walt Disney');

SELECT * FROM films2;
SELECT * FROM distributors2;

DELETE FROM distributors2 WHERE did=101;

SELECT * FROM films2;
SELECT * FROM distributors2;

DROP TRIGGER if_film_exits ON distributors2;
DROP TABLE films2, distributors2 CASCADE;
